-- Hand Controller macroscript
--
-- Created:  		
-- Last Updated:	Oct 12 2000
--
-- Author :   Fred Ruff
-- Version:  3ds max 4
--
-- 
-- This script is a basic system to make animating hands easier
--***********************************************************************************************
-- MODIFY THIS AT YOUR OWN RISK

macroScript HandController 
category:"MAX Script Tools"
internalCategory:"MAX Script Tools"
tooltip:"Hand Controller" 
buttontext:"Hand Controller"  
(
	global findhands
	global RtThumbCur 
	global RtForeCur 
	global RtMidCur
	global LfThumbCur 
	global LfMidCur
	global LfForeCur 			
	global RtFingerCur
	global LfFingerCur 
-- ********************************************* Begin Hand Controller script ********************************************
-- Create Function for Finding Hands in the scene 
global handuiarray = #()
local inc=0
 rollout HandCont "Hand System" width:400 height:173
 (
 	label Rotn "Right Hand" pos:[33,7] width:54 height:13 offset:[-140,0]
 	label l5 "Left Hand" pos:[177,8] width:47 height:13 offset:[0,-17]

 	slider RtFingersUI "" pos:[10,20] width:24 height:80 range:[-50,50,0] orient:#vertical ticks:0
 	slider RtMidUI "" pos:[45,20] width:24 height:80 range:[-50,50,0] orient:#vertical ticks:0
 	slider RtForeUI "" pos:[70,20] width:24 height:80 range:[-50,50,0] orient:#vertical ticks:0
 	slider RtThumbUI "" pos:[95,20] width:24 height:80 range:[-70,70,0] orient:#vertical ticks:0
 	slider LfThumbUI "" pos:[160,20] width:24 height:80 range:[-70,70,0] orient:#vertical ticks:0
 	slider LfForeUI "" pos:[185,20] width:24 height:80 range:[-50,50,0] orient:#vertical ticks:0
 	slider LfMidUI "" pos:[210,20] width:24 height:80 range:[-50,50,0] orient:#vertical ticks:0
 	slider LfFingersUI "" pos:[245,20] width:24 height:80 range:[-50,50,0] orient:#vertical ticks:0
	
 	label handuitext1 "Hand Sets" pos:[290,5] width:50 height:13
 	listbox handnameui "" pos:[290,20] width:65 height:8

 	button ReInitRTFingers "-" pos:[10,100] width:19 height:21
 	button ReInitRTMid "-" pos:[45,100] width:19 height:21
 	button ReInitRTFore "-" pos:[70,100] width:19 height:21
 	button ReInitRTThumb "-" pos:[95,100] width:19 height:21
 	button ReInitLFThumb "-" pos:[160,100] width:19 height:21
 	button ReInitLFFore "-" pos:[185,100] width:19 height:21
 	button ReInitLFMid "-" pos:[210,100] width:19 height:21
 	button ReInitLFFingers "-" pos:[245,100] width:19 height:21
 	button SelRall "Select All" pos:[10,125] width:60 height:21
 	button SelLall "Select All" pos:[160,125] width:60 height:21
 	button KeyRall "Key All" pos:[10,150] width:48 height:21
 	button KeyLall "Key All" pos:[160,150] width:48 height:21
 	button copyr "Copy" pos:[10,175] width:40 height:21 enabled:false
 	button paster "Paste" pos:[50,175] width:43 height:21 enabled:false
 	button copyl "Copy" pos:[160,175] width:40 height:21 enabled:false
 	button pastel "Paste" pos:[200,175] width:43 height:21 enabled:false
	
 	button findhandbutton "Find Hands" pos:[287,140] width:70 height:21
-- Added 1.28.00 buttons for selecting all bones in each hand (Purley for animation editing reasons)
-- Added 1.28.00 Set Key button for each hand
-- Added 1.28.00 Copy Paste Buttons?
	
	
	
	
	
-- Selecting named hand sets


-- Right Thumb Script Controls
	
	
	
-- Right Fore Finger Script Controls
	
-- Right Mid Finger Script Controls
	
-- Right Finger Script Controls

	

-- Left Thumb Script Controls

-- Left Fore Finger Script Controls

-- Left Mid Finger Script Controls
	
-- Left Finger Script Controls

	
	
 	on RtFingersUI changed value do
  	(
 		Inc = value - RtFingerCur
 		Undo on
 		(
 			In coordsys local
 			(
 				
 				Rotate (execute ("$" + HandCont.HandNameui.selected + "boneRtFinger*")) -inc x_axis	
 			)
 		RtFingerCur = RtFingerCur + inc
 		)
 	)

 	on RtFingersUI buttondown Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneRtFinger*")) true

 	on RtFingersUI buttonup Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneRtFinger*")) false

 	on RtMidUI changed value do
  	(
 		Inc = value - RtMidCur
 		Undo on
 		(
 			In coordsys local
 			(
 				
 				Rotate (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerMid*")) -inc x_axis	
 			)
 		RtMidCur = RtMidCur + inc
 		)
 	)

 	on RtMidUI buttondown Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerMid*")) true

 	on RtMidUI buttonup Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerMid*")) false

 	on RtForeUI changed value do
  	(
 		Inc = value - RtForeCur
 		Undo on
 		(
 			In coordsys local
 			(
 				
 				Rotate (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerFore*")) -inc x_axis	
 			)
 		RtForeCur = RtForeCur + inc
 		)
 	)

 	on RtForeUI buttondown Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerFore*")) true

 	on RtForeUI buttonup Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerFore*")) false

 	on RtThumbUI changed value do
  	(
 		Inc = value - RtThumbCur
 		Undo on
 		(
 			In coordsys local
 			(
 				Rotate (execute ("$" + HandCont.HandNameui.selected + "boneRtThumb*")) -inc x_axis	
 			)
 		RtThumbCur = RtThumbCur + inc
 		)
 	)

 	on RtThumbUI buttondown Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneRtThumb*")) true

 	on RtThumbUI buttonup Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneRtThumb*")) false

 	on LfThumbUI changed value do
  	(
 		Inc = value - LfThumbCur
 		Undo on
 		(
 			In coordsys local
 			(
 				Rotate (execute ("$" + HandCont.HandNameui.selected + "boneLfThumb*")) -inc x_axis	
 			)
 		LfThumbCur = LfThumbCur + inc
 		)
 	)

 	on LfThumbUI buttondown Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneLfThumb*"))true

 	on LfThumbUI buttonup Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneLfThumb*")) false

 	on LfForeUI changed value do
  	(
 		Inc = value - LfForeCur
 		Undo on
 		(
 			In coordsys local
 			(
 				Rotate (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerFore*")) -inc x_axis	
 			)
 		LfForeCur = LfForeCur + inc
 		)
 	)

 	on LfForeUI buttondown Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerFore*")) true

 	on LfForeUI buttonup Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerFore*")) false

 	on LfMidUI changed value do
  	(
 		Inc = value - LFMidCur
 		Undo on
 		(
 			In coordsys local
 			(
 				
 				Rotate (execute ("$" + HandCont.HandNameui.selected + "boneLFFingerMid*")) -inc x_axis	
 			)
 		LFMidCur = LFMidCur + inc
 		)
 	)

 	on LfMidUI buttondown Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerMid*")) true

 	on LfMidUI buttonup Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerMid*")) false

 	on LfFingersUI changed value do
  	(
 		format "before LfFingerCur 5\n" LfFingerCur
 		Inc = (value - LfFingerCur)
 		Undo on
 		(
 			In coordsys local
 			(
 				Rotate (execute ("$" + HandCont.HandNameui.selected + "boneLfFinger*")) -inc x_axis	
 			)
 		LfFingerCur = LfFingerCur + inc
 		format "inc %\n" inc
 		
 		)
 	)

 	on LfFingersUI buttondown Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneLfFinger*")) true

 	on LfFingersUI buttonup Do
 	 	flagForeground (execute ("$" + HandCont.HandNameui.selected + "boneLfFinger*")) false

 	on handnameui selected arg do
  	(
 		RtFingersUI.value = 0
 		RtMidUI.value = 0
 		RtForeUI.value = 0
 		RtThumbUI.value = 0
 		LfThumbUI.value = 0
 		LfForeUI.value	= 0
 		LfMidUI.value = 0
 		LfFingersUI.value = 0
 		select (execute ("$" + HandCont.HandNameui.selected + "bone??Hand*"))
 	)

 	on ReInitRTFingers pressed do
  	(
 		RtFingerCur = (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerMid02")).rotation.x
 		RtFingersUI.value = 0
 	)

 	on ReInitRTMid pressed do
  	(
 		RtMidCur = (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerMid00")).rotation.x
 		RtMidUI.value = 0
 	)

 	on ReInitRTFore pressed do
  	(
 		RtForeCur = (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerFore00")).rotation.x
 		RtForeUI.value = 0
 	)

 	on ReInitRTThumb pressed do
  	(
 		RtThumbCur = (execute ("$" + HandCont.HandNameui.selected + "boneRtThumb00")).rotation.x
 		RtThumbUI.value = 0
 	)

 	on ReInitLFThumb pressed do
  	(
 		LfThumbCur = (execute ("$" + HandCont.HandNameui.selected + "boneLfThumb00")).rotation.x
 		LfThumbUI.value = 0
 	)

 	on ReInitLFFore pressed do
  	(
 		LfForeCur = (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerFore00")).rotation.x
 		LfForeUI.value = 0
 	)

 	on ReInitLFMid pressed do
  	(
 		LFMidCur = (execute ("$" + HandCont.HandNameui.selected + "boneLFFingerMid00")).rotation.x
 		LFMidUI.value = 0
 	)

 	on ReInitLFFingers pressed do
  	(
 		LfFingerCur = (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerMid00")).rotation.x
 		LfFingersUI.value = 0
 	)

 	on SelRall pressed do
 	 	select (execute ("$" + HandCont.HandNameui.selected + "boneRt*"))

 	on SelLall pressed do
 	 	select (execute ("$" + HandCont.HandNameui.selected + "boneLf*"))

 	on KeyRall pressed do
  	(
 		local oldsel= selection as array
 		select (execute ("$" + HandCont.HandNameui.selected + "boneRt*"))
 		tempsel = selection as array
 		for i = 1 to tempsel.count do addnewkey tempsel[i].rotation.controller currenttime
 		select oldsel
 	)

 	on KeyLall pressed do
  	(
 		local oldsel= selection as array
 		select (execute ("$" + HandCont.HandNameui.selected + "boneLf*"))
 		tempsel = selection as array
 		for i = 1 to tempsel.count do addnewkey tempsel[i].rotation.controller currenttime
 		select oldsel
 	)

 	on copyr pressed do
  	(
 		global Rtbuffer = #()
 		local oldsel= selection as array
 		select (execute ("$" + HandCont.HandNameui.selected + "boneRt*"))
 		tempsel = selection as array
 		for i = 1 to tempsel.count do RTbuffer[i] =  tempsel[i].transform
 		select oldsel
 		print RTbuffer
 	)

 	on paster pressed do
  	(
 	undo on
 		(
 		print "pasted"
 		local oldsel= selection as array
 		select (execute ("$" + HandCont.HandNameui.selected + "boneRt*"))
 	
 		tempsel = selection as array
 		for i = 1 to tempsel.count do tempsel[i].transform = RTbuffer[i]
 		select oldsel
 		)
 	)

 	on copyl pressed do
  	(
 		global Rtbuffer = #()
 		local oldsel= selection as array
 		select (execute ("$" + HandCont.HandNameui.selected + "boneLf*"))
 		tempsel = selection as array
 		for i = 1 to tempsel.count do RTbuffer[i] = tempsel[i].transform
 		select oldsel
 		print RTbuffer
 	)

 	on pastel pressed do
  	(
 	undo on
 		(
 		print "pasted"
 		local oldsel= selection as array
 		select (execute ("$" + HandCont.HandNameui.selected + "boneLf*"))
 		tempsel = selection as array
 		for i = 1 to tempsel.count do tempsel[i].transform = RTbuffer[i]
 		select oldsel
 		)
 	)

 	on findhandbutton pressed do
 	 	FindHands()
 )
-- Begining of script	 	
CreateDialog HandCont width:400 height:188 style:#(#style_titlebar,#Style_toolwindow,#style_sysmenu)
	function FindHands =
	(
		handuiarray = #()
		local tempsel = selection as array
		print "Opened"
		
		try 
		(
			Select $*boneRtHand*
			tempbones = selection as array
		)
		catch 	messagebox "No Hand Bones in Scene! Please use the Hand Builder macroscript." title:"Need Hands from Hand Builder"

	-- exctract the string from the front and put it into list box
			if tempbones.count == 1 then
				(
				print "Only one set"
				q = tempbones[1].name
				print q
				s = substring q 1 6
				append handuiarray s
				)
			else 			
			(
				print "Found more than one set"
				for i = 1 to tempbones.count do
				(
				q = tempbones[i].name
				print q
				s = substring q 1 6
				append handuiarray s
				print handuiarray
				)
			)
	HandCont.handnameui.items = handuiarray
	HandCont.handnameui.selection = 1
		try
		(
			global Handfloaterpos = [10,100] 
			global RtThumbCur = (execute ("$" + HandCont.HandNameui.selected + "boneRtThumb00")).rotation.x
			global RtForeCur = (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerFore00")).rotation.x
			global RtMidCur = (execute ("$" + HandCont.HandNameui.selected + "boneRtFingerMid00")).rotation.x	
			global LfThumbCur = (execute ("$" + HandCont.HandNameui.selected + "boneLfThumb00")).rotation.x
			global LfMidCur = (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerMid00")).rotation.x
			global LfForeCur = (execute ("$" + HandCont.HandNameui.selected + "boneLfFingerFore00")).rotation.x
			

		)
		catch 
		(
			print HandCont.HandNameui.selected
			--print (execute ("$" + HandCont.HandNameui.selected + "boneRtThumb00"))
			messagebox "No Hand Bones in Scene! Please use the Hand Builder macroscript." title:"Need Hands from Hand Builder"
			DestroyDialog HandCont
			End
		)
		try
		(
			global RtFingerCur = (execute ("$" + HandCont.HandNameui.selected + "boneRtFinger00")).rotation.x
			global LfFingerCur = (execute ("$" + HandCont.HandNameui.selected + "boneLfFinger00")).rotation.x
		)
		Catch()
			print LfFingerCur
		select tempsel
	)
	FindHands()

)


-- Hand Builder macroscript
--
-- Created:  		??
-- Last Updated:	Oct 12 2000
--
-- Author :   Fred Ruff
-- Version:  3D Studio Max Version 4.0
--
-- 
-- This script builds a set of hands to be used with the HandController script
--***********************************************************************************************
-- MODIFY THIS AT YOUR OWN RISK

macroScript HandBuilder 
category:"MAX Script Tools" 
tooltip:"Hand Builder" 
buttontext:"Hand Builder" 
-- Version 2.0
(
	rollout handnameRollout "Hand Name"
	(
		label l1 "Please Give This set of Hands a Name."
		label l2 "Use 6 Characters EXACTLY please"
		edittext handname "Hand Set Name:" offset:[0,10] text:"HandsA" fieldwidth:50
		radiobuttons fcount "Number of Fingers:" labels:#("3","4","5") default:3
		button next "Continue ->" offset:[50,0]
		
		On Next pressed do
		(	
			s = substring handname.text 1 6
			handname.text = s
			undo on
			(
			max display mode
			ProgressStart "Building Parametric Bones."
			--Index Finger
			boneRtFingerFore00 = Box name:(handname.text +"boneRtFingerFore00") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:74 pos:[0,0,0] wirecolor:(color 28 28 177) isSelected:on
			boneRtFingerFore01 = Box name:(handname.text +"boneRtFingerFore01") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:72 pos:[0,-3.33253e-006,76.2393] wirecolor:(color 28 28 177) isSelected:on
			boneRtFingerFore02 = Box name:(handname.text +"boneRtFingerFore02") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:70 pos:[0,-6.59319e-006,150.835] wirecolor:(color 28 28 177) isSelected:on
			ProgressUpdate 8
			
			--Middle Finger
			boneRtFingerMid00 = Box name:(handname.text +"boneRtFingerMid00") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:80 pos:[-67.5689,0,0] wirecolor:(color 88 88 200) isSelected:on
			boneRtFingerMid01 = Box name:(handname.text +"boneRtFingerMid01") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:78 pos:[-67.5689,-3.72745e-006,85.274] wirecolor:(color 88 88 200) isSelected:on
			boneRtFingerMid02 = Box name:(handname.text +"boneRtFingerMid02") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:76 pos:[-67.5689,-7.32461e-006,167.568] wirecolor:(color 88 88 200) isSelected:on
			ProgressUpdate 16
			--Finger 1
			if fcount.state >= 2 do
			(
			boneRtFinger00 = Box name:(handname.text +"boneRtFinger00") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:72 pos:[-138.561,0,0] wirecolor:(color 88 88 200) isSelected:on
			boneRtFinger01 = Box name:(handname.text +"boneRtFinger01") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:70 pos:[-138.561,-3.33501e-006,76.296] wirecolor:(color 88 88 200) isSelected:on
			boneRtFinger02 = Box name:(handname.text +"boneRtFinger02") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:68 pos:[-138.561,-6.58023e-006,150.538] wirecolor:(color 88 88 200) isSelected:on
			)
			ProgressUpdate 24
			--Finger 2
			if fcount.state == 3 do
			(
			boneRtFinger10 = Box name:(handname.text +"boneRtFinger10") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:65 pos:[-198.561,0,0] wirecolor:(color 88 88 200) isSelected:on
			boneRtFinger11 = Box name:(handname.text +"boneRtFinger11") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:63 pos:[-198.561,-3.03785e-006,69.4979] wirecolor:(color 88 88 200) isSelected:on
			boneRtFinger12 = Box name:(handname.text +"boneRtFinger12") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:61 pos:[-198.561,-5.84691e-006,133.762] wirecolor:(color 88 88 200) isSelected:on
			)
			ProgressUpdate 32
			
			--Thumb
			boneRtThumb00 = Box name:(handname.text +"boneRtThumb00") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:65 pos:[45.6871,0,-166.197] wirecolor:(color 88 88 200) isSelected:on
			boneRtThumb01 = Box name:(handname.text +"boneRtThumb01") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:63 pos:[45.6871,0,-96.34] wirecolor:(color 88 88 200) isSelected:on
			boneRtThumb02 = Box name:(handname.text +"boneRtThumb02") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:61 pos:[45.6871,0,-23.1824] wirecolor:(color 88 88 200) isSelected:on
			ProgressUpdate 40
			--Hand
			boneRtHand = Box name:(handname.text +"boneRtHand") lengthsegs:1 widthsegs:1 heightsegs:1 length:66.7992 width:194.036 height:221.074 pos:[-98.8065,0,-261.77] wirecolor:(color 28 28 177) isSelected:on
			ProgressUpdate 48
			
			-- ********************   LEFT HAND NOW    ****************
			-- Index Finger
			
			boneLfFingerFore00 = Box name:(handname.text +"boneLfFingerFore00") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:74 pos:[285.016,0,-1.27547] wirecolor:(color 28 28 177) isSelected:on
			boneLfFingerFore01 = Box name:(handname.text +"boneLfFingerFore01") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:72 pos:[285.016,-3.33253e-006,75.9969] wirecolor:(color 28 28 177) isSelected:on
			boneLfFingerFore02 = Box name:(handname.text +"boneLfFingerFore02") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:70 pos:[285.016,-6.59319e-006,152.695] wirecolor:(color 28 28 177) isSelected:on
			ProgressUpdate 56
			--Middle Finger
			boneLfFingerMid00 = Box name:(handname.text +"boneLfFingerMid00") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:80 pos:[337.902,0,0] wirecolor:(color 88 88 200) isSelected:on
			boneLfFingerMid01 = Box name:(handname.text +"boneLfFingerMid01") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:78 pos:[337.902,-3.72745e-006,85.274] wirecolor:(color 88 88 200) isSelected:on
			boneLfFingerMid02 = Box name:(handname.text +"boneLfFingerMid02") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:76 pos:[337.902,-7.32461e-006,167.568] wirecolor:(color 88 88 200) isSelected:on
			ProgressUpdate 73
			--Finger 1
			if fcount.state >= 2 do
			(
			boneLfFinger00 = Box name:(handname.text +"boneLfFinger00") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:72 pos:[389.45,0,0] wirecolor:(color 88 88 200) isSelected:on
			boneLfFinger01 = Box name:(handname.text +"boneLfFinger01") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:70 pos:[389.45,-3.33501e-006,76.296] wirecolor:(color 88 88 200) isSelected:on
			boneLfFinger02 = Box name:(handname.text +"boneLfFinger02") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:68 pos:[389.45,-6.58023e-006,150.538] wirecolor:(color 88 88 200) isSelected:on
			)
			ProgressUpdate 81
			--Finger 2
			if fcount.state == 3 do
			(
			boneLfFinger10 = Box name:(handname.text +"boneLfFinger10") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:65 pos:[441.453,0,0] wirecolor:(color 88 88 200) isSelected:on
			boneLfFinger11 = Box name:(handname.text +"boneLfFinger11") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:63 pos:[441.453,-3.03785e-006,69.4979] wirecolor:(color 88 88 200) isSelected:on
			boneLfFinger12 = Box name:(handname.text +"boneLfFinger12") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:61 pos:[441.453,-5.84691e-006,133.762] wirecolor:(color 88 88 200) isSelected:on
			)
			ProgressUpdate 89
			--Thumb
			boneLfThumb00 = Box name:(handname.text +"boneLfThumb00") lengthsegs:1 widthsegs:1 heightsegs:1 length:39 width:39 height:65 pos:[220.109,0,-166.197] wirecolor:(color 88 88 200) isSelected:on
			boneLfThumb01 = Box name:(handname.text +"boneLfThumb01") lengthsegs:1 widthsegs:1 heightsegs:1 length:37 width:37 height:63 pos:[220.109,0,-96.34] wirecolor:(color 88 88 200) isSelected:on
			boneLfThumb02 = Box name:(handname.text +"boneLfThumb02") lengthsegs:1 widthsegs:1 heightsegs:1 length:35 width:35 height:61 pos:[220.109,0,-23.1824] wirecolor:(color 88 88 200) isSelected:on
			ProgressUpdate 96
			--Hand
			boneLfHand = Box name:(handname.text +"boneLfHand") lengthsegs:1 widthsegs:1 heightsegs:1 length:66.7992 width:194.036 height:221.074 pos:[361.6,1.59059,-246.518] wirecolor:(color 28 28 177) isSelected:on
			ProgressUpdate 100
			ProgressEnd()
			ProgressStart "Creating Bone Hierarchy."
			max link
		if fcount.state == 3 do
			(		
				select boneRtFinger12
				$.parent = boneRtFinger11
				select boneRtFinger11
				$.parent = boneRtFinger10
				select boneRtFinger10
				$.parent = boneRtHand
			)
			ProgressUpdate 10
		if fcount.state >= 2 do
			(
				select boneRtFinger02
				$.parent = boneRtFinger01
				select boneRtFinger01
				$.parent = boneRtFinger00
				select boneRtFinger00
				$.parent = boneRtHand
			)
			select boneRtFingerMid02
			ProgressUpdate 25
			$.parent = boneRtFingerMid01
			select boneRtFingerMid01
			$.parent = boneRtFingerMid00
			select boneRtFingerMid00
			$.parent = boneRtHand
			select boneRtFingerFore02
			ProgressUpdate 35
			$.parent = boneRtFingerFore01
			select boneRtFingerFore01
			$.parent = boneRtFingerFore00
			select boneRtFingerFore00
			$.parent = boneRtHand
			select boneRtThumb02
			$.parent = boneRtThumb01
			select boneRtThumb01
			$.parent = boneRtThumb00
			ProgressUpdate 50
			select boneRtThumb00
			$.parent = boneRtHand
		if fcount.state == 3 do
			(
			select boneLfFinger12
			$.parent = boneLfFinger11
			select boneLfFinger11
			$.parent = boneLfFinger10
			select boneLfFinger10
			$.parent = boneLfHand
			)
			ProgressUpdate 60
		if fcount.state >= 2 do
			(
			select boneLfFinger02
			$.parent = boneLfFinger01
			select boneLfFinger01
			$.parent = boneLfFinger00
			select boneLfFinger00
			$.parent = boneLfHand
			)
			select boneLfFingerMid02
			$.parent = boneLfFingerMid01
			select boneLfFingerMid01
			$.parent = boneLfFingerMid00
			ProgressUpdate 75
			select boneLfFingerMid00
			$.parent = boneLfHand
			select boneLfFingerFore02
			$.parent = boneLfFingerFore01
			select boneLfFingerFore01
			$.parent = boneLfFingerFore00
			select boneLfFingerFore00
			ProgressUpdate 85
			$.parent = boneLfHand
			select boneLfThumb02
			$.parent = boneLfThumb01
			select boneLfThumb01
			$.parent = boneLfThumb00
			select boneLfThumb00
			$.parent = boneLfHand

			ProgressUpdate 100
			ProgressEnd()
	-- Rotate the thumbs down a little
			set coordsys local
			boneRtThumb00.rotation = quat 0.0534677 0.218504 0.231594 0.946447
			boneLfThumb00.rotation = quat 0.0461609 -0.185141 -0.237477 0.952469

	-- The hands were originally build WAY too big, This makes them smaller
			execute ("scale $"+Handname.text+"boneRtHand [0.2,0.2,0.2]")
			execute ("scale $"+Handname.text+"boneLfHand [0.2,0.2,0.2]")
	
	-- Move the hands to the middle of the screen
			set coordsys world
			Execute ("$"+handname.text+"boneRtHand.pos = [-50,0,0]")
			Execute ("$"+handname.text+"boneLfHand.pos = [50,0,0]")
	
	-- Select the root of each hand at the end
			Execute ("select #($"+handname.text+"boneLfHand,$"+handname.text+"boneRtHand)")
			max tool zoomextents
			DestroyDialog Handnamerollout
			Messagebox "Scale the root of each hand to the appropriate size and position the fingers before skinning." title:"WARNING!"
			
			
			)
		)
	)
	CreateDialog Handnamerollout width:210 height:150 style:#(#style_titlebar,#Style_toolwindow,#style_sysmenu)

)
 